function det = leibniz( A )
%LEIBNIZ Berechnet die Determinante einer 3x3 oder 4x4 Matrix
%   3x3: Regel von Sarrus, 4x4: Entwicklung nach der ersten Zeile + Sarrus

% ACHTUNG: Benoetigt sarrus.m im selben Ordner!


%Plausibilitaetspruefung
[zeilen spalten] = size(A);
if( (zeilen ~= spalten) || (zeilen > 4) || (zeilen < 3))
    disp('Ungueltige Dimension!');

%Sarrus fuer 3x3-Matrizen
elseif (zeilen == 3)
    det = sarrus(A);

%Entwicklung nach der ersten Zeile
else
    det = A(1,1) * sarrus(A(2:4,2:4)) - A(1,2) * sarrus(A(2:4,[1 3:4])) + A(1,3) * sarrus(A(2:4,[1:2 4])) - A(1,4) * sarrus(A(2:4,1:3));
end


%FLOPS fuer Sarrus: 5 Additionen + 18 Multiplikationen = 23 Flops
%FLOPS fuer 4x4   : 4 * Sarrus + 4 Multiplikationen + 3 Additionen = 4 * 23 + 7 = 79 Flops
